function makebardec3annual(cmp1,titlelist,legendlist,figlabel,yearshock,step,maxperiod,ylabels,opts,...
    zdata1,zdata2,zdata3,zdata4,zdata5,zdata6,zdata7)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

nobs = size(zdata1,1);


%if maxperiod is defined, the nobs is calculated as such
if maxperiod > 0
    nobs = (maxperiod-yearshock)/step;
end



ndsets=7;       % default, changed below as applicable

if nargin==10
    zdata2=nan*zdata1;
    zdata3=nan*zdata1;
    zdata4=nan*zdata1;
    zdata5=nan*zdata1;
    zdata6=nan*zdata1;
    zdata7=nan*zdata1;
    ndsets =1;
    zdata(:,:,1) = zdata1;
elseif nargin==11
    zdata3=nan*zdata1;
    zdata4=nan*zdata1;
    zdata5=nan*zdata1;
    zdata6=nan*zdata1;
    zdata7=nan*zdata1;
    ndsets =2;
    zdata(:,:,1) = zdata1;
    zdata(:,:,2) = zdata2;
elseif nargin == 12
    zdata4 =nan*zdata1;
    zdata5 =nan*zdata1;
    zdata6=nan*zdata1;
    zdata7=nan*zdata1;
    ndsets=3;
    zdata(:,:,1) = zdata1;
    zdata(:,:,2) = zdata2;
    zdata(:,:,3) = zdata3;
elseif nargin == 13
    zdata5 =nan*zdata1;
    zdata6=nan*zdata1;
    zdata7=nan*zdata1;
    ndsets=4;
    zdata(:,:,1) = zdata1;
    zdata(:,:,2) = zdata2;
    zdata(:,:,3) = zdata3;
    zdata(:,:,4) = zdata4;
elseif nargin == 14
    zdata6 =nan*zdata1;
    zdata7=nan*zdata1;
    ndsets=5;
    zdata(:,:,1) = zdata1;
    zdata(:,:,2) = zdata2;
    zdata(:,:,3) = zdata3;
    zdata(:,:,4) = zdata4;
    zdata(:,:,5) = zdata5;
elseif nargin == 15
    zdata7=nan*zdata1;
    ndsets=6;
    zdata(:,:,1) = zdata1;
    zdata(:,:,2) = zdata2;
    zdata(:,:,3) = zdata3;
    zdata(:,:,4) = zdata4;
    zdata(:,:,5) = zdata5;
    zdata(:,:,6) = zdata6;
elseif ((nargin>=15) || (nargin <=4))
    error ('makechart takes 5 to 11 arguments')
end


if yearshock>-100
    xvalues = yearshock+(0:nobs-1)'*step; % Matteo plot year on x axis
else
    xvalues = (1:nobs)'; % Matteo plot year on x axis
end

nvars = size(titlelist,1);
nshocks = size(legendlist,1)-1;

if nvars==1
    nrows=1;
    ncols = 1;
elseif nvars==2
    nrows =2;
    ncols = 1;
elseif nvars == 3
    nrows = 3;
    ncols = 1;
elseif nvars==4
    nrows = 2;
    ncols = 2;
elseif (nvars==5 || nvars ==6)
    nrows = 3;
    ncols = 2;
elseif (nvars==7 || nvars==8)
    nrows = 4;
    ncols = 2;
elseif nvars>8 && nvars<=12;
    nrows = 3;
    ncols = 4;
elseif nvars>12 && nvars<=15;
    nrows = 5;
    ncols = 3;
else
    error('too many variables (makechart)')
end


for i = 1:nvars
    var(i).title = titlelist(i,:);
    for t  = 1:nobs
        for indi = 2 : nshocks+1
            var(i).min(t,indi-1) = min(zdata(t, i, indi),0);
            var(i).max(t,indi-1) = max(zdata(t, i, indi),0);
            var(i).total(t) = (zdata(t, i, 1));
        end
    end
end

colormap default
colormap(cmp1)

year = floor(xvalues);

for i = 1:nvars
    var(i).subplot=subplot(nrows,ncols,i);
    plot(xvalues,var(i).total,'k','Linewidth',2)
    hold on
    bmax = bar(xvalues,var(i).max,'stack');colormap(cmp1)
    set(bmax,'ShowBaseLine','off')
    bmin = bar(xvalues,var(i).min,'stack');colormap(cmp1)
    set(bmin,'ShowBaseLine','off')
    hold on
    plot(xvalues,var(i).total,'k','Linewidth',2)
    axis('tight')    
    
    [x0 x1 y0 y1] = pickaxes(xvalues,var(i).total(:,i));
    %axis([var(i)subplot],[x0 x1 y0 y1])
    hold on
    
    title(var(i).subplot,[var(i).title])

    if i==1
	if numel(strvcat(legendlist(1,:)))
	    h=legend(legendlist,'Location','Southeast','Orientation','Horizontal');	    
	    legend('boxoff')
        legendmarkeradjust(1)
	    set(h,'Fontsize',8)
	end
    end


    
    if i==1
        if nvars>3
            text('String',figlabel,'Units','normalized','Position',[1.2 1.21],...
                'FontSize',12,'FontWeight','bold','HorizontalAlignment','center');
        else
            text('String',figlabel,'Units','normalized','Position',[0.4 1.24],...
                'FontSize',12,'FontWeight','bold','HorizontalAlignment','center');
        end
    end
    
end

newUnits = 'normalized';
set(h,'Position',opts.legendplace,'Units',newUnits)
